diff mbox series

[v2,1/2] selftests: livepatch: add new ftrace helpers functions

Message ID 20250318-ftrace-sftest-livepatch-v2-1-60cb0aa95cca@gmail.com
State Superseded
Headers show
Series selftests: livepatch: test if ftrace can trace a livepatched function | expand

Commit Message

Filipe Xavier March 18, 2025, 9:20 p.m. UTC
Add new ftrace helpers functions cleanup_tracing, trace_function and
check_traced_functions.

Signed-off-by: Filipe Xavier <felipeaggger@gmail.com>
---
 tools/testing/selftests/livepatch/functions.sh | 49 ++++++++++++++++++++++++++
 1 file changed, 49 insertions(+)

Comments

Joe Lawrence March 24, 2025, 6:22 p.m. UTC | #1
On Tue, Mar 18, 2025 at 06:20:35PM -0300, Filipe Xavier wrote:
> Add new ftrace helpers functions cleanup_tracing, trace_function and
> check_traced_functions.
> 
> Signed-off-by: Filipe Xavier <felipeaggger@gmail.com>
> ---
>  tools/testing/selftests/livepatch/functions.sh | 49 ++++++++++++++++++++++++++
>  1 file changed, 49 insertions(+)
> 
> diff --git a/tools/testing/selftests/livepatch/functions.sh b/tools/testing/selftests/livepatch/functions.sh
> index 15601402dee6567837c2c49ba342eb357e410d18..dea9cc10a3f09662c57c2593cff49423302c8a5c 100644
> --- a/tools/testing/selftests/livepatch/functions.sh
> +++ b/tools/testing/selftests/livepatch/functions.sh
> @@ -10,6 +10,7 @@ SYSFS_KERNEL_DIR="/sys/kernel"
>  SYSFS_KLP_DIR="$SYSFS_KERNEL_DIR/livepatch"
>  SYSFS_DEBUG_DIR="$SYSFS_KERNEL_DIR/debug"
>  SYSFS_KPROBES_DIR="$SYSFS_DEBUG_DIR/kprobes"
> +SYSFS_TRACING_DIR="$SYSFS_DEBUG_DIR/tracing"
>  
>  # Kselftest framework requirement - SKIP code is 4
>  ksft_skip=4
> @@ -62,6 +63,9 @@ function push_config() {
>  			awk -F'[: ]' '{print "file " $1 " line " $2 " " $4}')
>  	FTRACE_ENABLED=$(sysctl --values kernel.ftrace_enabled)
>  	KPROBE_ENABLED=$(cat "$SYSFS_KPROBES_DIR/enabled")
> +	TRACING_ON=$(cat "$SYSFS_TRACING_DIR/tracing_on")
> +	CURRENT_TRACER=$(cat "$SYSFS_TRACING_DIR/current_tracer")
> +	FTRACE_FILTER=$(cat "$SYSFS_TRACING_DIR/set_ftrace_filter")
>  }
>  
>  function pop_config() {
> @@ -74,6 +78,17 @@ function pop_config() {
>  	if [[ -n "$KPROBE_ENABLED" ]]; then
>  		echo "$KPROBE_ENABLED" > "$SYSFS_KPROBES_DIR/enabled"
>  	fi
> +	if [[ -n "$TRACING_ON" ]]; then
> +		echo "$TRACING_ON" > "$SYSFS_TRACING_DIR/tracing_on"
> +	fi
> +	if [[ -n "$CURRENT_TRACER" ]]; then
> +		echo "$CURRENT_TRACER" > "$SYSFS_TRACING_DIR/current_tracer"
> +	fi
> +	if [[ -n "$FTRACE_FILTER" ]]; then
> +		echo "$FTRACE_FILTER" \
> +			| sed -e "/#### all functions enabled ####/d"
> +			> "$SYSFS_TRACING_DIR/set_ftrace_filter"
> +	fi
>  }
>  
>  function set_dynamic_debug() {
> @@ -352,3 +367,37 @@ function check_sysfs_value() {
>  		die "Unexpected value in $path: $expected_value vs. $value"
>  	fi
>  }
> +
> +# cleanup_tracing() - stop and clean up function tracing
> +function cleanup_tracing() {
> +	echo 0 > "$SYSFS_TRACING_DIR/tracing_on"
> +	echo "" > "$SYSFS_TRACING_DIR/set_ftrace_filter"
> +	echo "nop" > "$SYSFS_TRACING_DIR/current_tracer"
> +	echo "" > "$SYSFS_TRACING_DIR/trace"
> +}
> +
> +# trace_function(function) - start tracing of a function
> +#	function - to be traced function
> +function trace_function() {
> +	local function="$1"; shift
> +
> +	cleanup_tracing
> +
> +	echo "function" > "$SYSFS_TRACING_DIR/current_tracer"
> +	echo "$function" > "$SYSFS_TRACING_DIR/set_ftrace_filter"
> +	echo 1 > "$SYSFS_TRACING_DIR/tracing_on"
> +}
> +
> +# check_traced_functions(functions...) - check whether each function appeared in the trace log
> +#	functions - list of functions to be checked
> +function check_traced_functions() {
> +	local function
> +
> +	for function in "$@"; do
> +		if ! grep -q "$function" "$SYSFS_TRACING_DIR/trace" ; then

Small suggestion here: grep on "$function" may find partial string
matches, like:

  $ echo 'hamburger' | grep 'ham'
  hamburger

so it's probably safer to user --word-regexp to avoid longer function
names inadvertently matching:

  $ echo 'hamburger' | grep -w 'ham'
  $ echo 'ham' | grep -w 'ham'
  ham

Also, maybe also --fixed-strings for the extra paranoid?  Off the top of
my head, I don't think any C function characters are special regex (like
$ ^ [ ] etc.) so it's probably safe w/o.

-- Joe
Filipe Xavier March 24, 2025, 10:49 p.m. UTC | #2
On 3/24/25 3:36 PM, Joe Lawrence wrote:

> On Tue, Mar 18, 2025 at 06:20:35PM -0300, Filipe Xavier wrote:
>> [ ... snip ... ]
>>
>> +	if [[ -n "$FTRACE_FILTER" ]]; then
>> +		echo "$FTRACE_FILTER" \
>> +			| sed -e "/#### all functions enabled ####/d"
>> +			> "$SYSFS_TRACING_DIR/set_ftrace_filter"
>> +	fi
>    
> Also, this may be more stylistic than a functional nit (I don't know for
> sure), but shellcheck [1] seemed confused about these lines:
>
>     In tools/testing/selftests/livepatch/functions.sh line 90:
>                            > "$SYSFS_TRACING_DIR/set_ftrace_filter"
>                            ^-- SC2188 (warning): This redirection doesn't have a command. Move to its command (or use 'true' as no-op).
>
> I wasn't going to comment on these until I saw shellcheck note them, but
> I thought shell script convention was typically to end the line with the
> redirection/pipe then escape the end of line like:
>
>    commands | commands > \
>        tee output.txt
>
> There are a few existing examples of this pattern if you grep the
> functions.sh file for '\\$'.
>
> That said, I'm far from certain whether which order is better than the
> other.  The only reason for bringing it up is that shellcheck warns on
> this patch's usage.
>
> [1] https://www.shellcheck.net/
>
> -- Joe

Thanks for review Joe, I'm sending a new version with all the fixes.

Cheers

Filipe
diff mbox series

Patch

diff --git a/tools/testing/selftests/livepatch/functions.sh b/tools/testing/selftests/livepatch/functions.sh
index 15601402dee6567837c2c49ba342eb357e410d18..dea9cc10a3f09662c57c2593cff49423302c8a5c 100644
--- a/tools/testing/selftests/livepatch/functions.sh
+++ b/tools/testing/selftests/livepatch/functions.sh
@@ -10,6 +10,7 @@  SYSFS_KERNEL_DIR="/sys/kernel"
 SYSFS_KLP_DIR="$SYSFS_KERNEL_DIR/livepatch"
 SYSFS_DEBUG_DIR="$SYSFS_KERNEL_DIR/debug"
 SYSFS_KPROBES_DIR="$SYSFS_DEBUG_DIR/kprobes"
+SYSFS_TRACING_DIR="$SYSFS_DEBUG_DIR/tracing"
 
 # Kselftest framework requirement - SKIP code is 4
 ksft_skip=4
@@ -62,6 +63,9 @@  function push_config() {
 			awk -F'[: ]' '{print "file " $1 " line " $2 " " $4}')
 	FTRACE_ENABLED=$(sysctl --values kernel.ftrace_enabled)
 	KPROBE_ENABLED=$(cat "$SYSFS_KPROBES_DIR/enabled")
+	TRACING_ON=$(cat "$SYSFS_TRACING_DIR/tracing_on")
+	CURRENT_TRACER=$(cat "$SYSFS_TRACING_DIR/current_tracer")
+	FTRACE_FILTER=$(cat "$SYSFS_TRACING_DIR/set_ftrace_filter")
 }
 
 function pop_config() {
@@ -74,6 +78,17 @@  function pop_config() {
 	if [[ -n "$KPROBE_ENABLED" ]]; then
 		echo "$KPROBE_ENABLED" > "$SYSFS_KPROBES_DIR/enabled"
 	fi
+	if [[ -n "$TRACING_ON" ]]; then
+		echo "$TRACING_ON" > "$SYSFS_TRACING_DIR/tracing_on"
+	fi
+	if [[ -n "$CURRENT_TRACER" ]]; then
+		echo "$CURRENT_TRACER" > "$SYSFS_TRACING_DIR/current_tracer"
+	fi
+	if [[ -n "$FTRACE_FILTER" ]]; then
+		echo "$FTRACE_FILTER" \
+			| sed -e "/#### all functions enabled ####/d"
+			> "$SYSFS_TRACING_DIR/set_ftrace_filter"
+	fi
 }
 
 function set_dynamic_debug() {
@@ -352,3 +367,37 @@  function check_sysfs_value() {
 		die "Unexpected value in $path: $expected_value vs. $value"
 	fi
 }
+
+# cleanup_tracing() - stop and clean up function tracing
+function cleanup_tracing() {
+	echo 0 > "$SYSFS_TRACING_DIR/tracing_on"
+	echo "" > "$SYSFS_TRACING_DIR/set_ftrace_filter"
+	echo "nop" > "$SYSFS_TRACING_DIR/current_tracer"
+	echo "" > "$SYSFS_TRACING_DIR/trace"
+}
+
+# trace_function(function) - start tracing of a function
+#	function - to be traced function
+function trace_function() {
+	local function="$1"; shift
+
+	cleanup_tracing
+
+	echo "function" > "$SYSFS_TRACING_DIR/current_tracer"
+	echo "$function" > "$SYSFS_TRACING_DIR/set_ftrace_filter"
+	echo 1 > "$SYSFS_TRACING_DIR/tracing_on"
+}
+
+# check_traced_functions(functions...) - check whether each function appeared in the trace log
+#	functions - list of functions to be checked
+function check_traced_functions() {
+	local function
+
+	for function in "$@"; do
+		if ! grep -q "$function" "$SYSFS_TRACING_DIR/trace" ; then
+			die "Function ($function) did not appear in the trace"
+		fi
+	done
+
+	cleanup_tracing
+}